diff -urN v2.4.10/mm/memory.c foo/mm/memory.c
--- v2.4.10/mm/memory.c	Mon Sep 24 02:16:05 2001
+++ foo/mm/memory.c	Tue Sep 25 20:03:04 2001
@@ -319,7 +319,9 @@
 		if (pte_none(pte))
 			continue;
 		if (pte_present(pte)) {
-			freed ++;
+			struct page *page = pte_page(pte);
+			if (!PageReserved(page) && VALID_PAGE(page))
+				freed ++;
 			/* This will eventually call __free_pte on the pte. */
 			tlb_remove_page(tlb, ptep, address + offset);
 		} else {
